/* 
 * chrfinp.h
 *
 * include file for RF ramping device server
 *
 *
 */

/* max number of call-routines in the server */
#define N_AM 9

/* loop parameters */
#define N_LOOPS 2    	/* number of loops in server, see after */
#define VLT_RAMP   0  	/* loop index of voltage ramp */
#define FAST_RAMP  1  	/* loop index of voltage fast ramp */
#define RAMP_TICKS 10 	/* loop ticks */

#define RAMP_MSK	0x2	/* mask used to set "ramp running" bit in status call */

typedef char devname_t[20];       /* type for device name */

/* ADIO (adc/dac) structure channel */
typedef struct adioch_s {
	double a,  /* calibration parameters: ax^3 + bx^2 + cx + d */
  			 b,
  			 c,
  			 d,
				 min,		/* min voltage value */
  			 max;		/* max voltage value */  				 
} adioch_t;

/* RF voltage ramping resources structure */
typedef struct adio_s{
  devname_t devname;          /* device name */
	double max_vel,
				 max_fast_ramp;	
	int fast_time;					/* sec. */			 
  unsigned short in_mask,     /* inputs definition */
  							 enable_mask; /* enable command mask */
  adioch_t adc,
					 dac,
					 dac_set;
} adio_t;

/*
 * resource struct definition
 */
typedef struct {
	adio_t adio;		/* one ADIO */
} resource_type;

/* EOF */
