/*----- PROTECTED REGION ID(RfInp.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfInp.h
//
// description : Include file for the RfInp class
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef RfInp_H
#define RfInp_H

#include <tango/tango.h>

#include "dio.h"
#include "adc.h"
#include "dac.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInp.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  RfInp class description:
 *    
 */


namespace RfInp_ns
{
/*----- PROTECTED REGION ID(RfInp::Additional Class Declarations) ENABLED START -----*/
/* clang-format on */
class RfInpWorker;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInp::Additional Class Declarations

class RfInp : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(RfInp::Data Members) ENABLED START -----*/
/* clang-format on */
	string initError;

	ADC *vltADC;
	DAC *vltDAC;
	DIO *enableInDIO, *enableOutDIO;
	
	RfInpWorker *worker;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInp::Data Members

//	Device property data members
public:
	//	EnableInDevice:	
	std::string	enableInDevice;
	//	EnableOutDevice:	
	std::string	enableOutDevice;
	//	MaxVltStep:	
	Tango::DevDouble	maxVltStep;
	//	adcCalibration:	
	std::vector<Tango::DevDouble>	adcCalibration;
	//	adcDevice:	
	std::string	adcDevice;
	//	dacCalibration:	
	std::vector<Tango::DevDouble>	dacCalibration;
	//	dacDevice:	
	std::string	dacDevice;
	//	dacSetCalibration:	
	std::vector<Tango::DevDouble>	dacSetCalibration;
	//	fastRampTarget:	Fast ramp target in kV
	Tango::DevDouble	fastRampTarget;
	//	fastRampTime:	Fast ramp duration in seconds
	Tango::DevUShort	fastRampTime;
	//	pollingSleep:	Sleep in ms between hardware interaction
	Tango::DevUShort	pollingSleep;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_vlt_read;
	Tango::DevDouble	*attr_vltSet_read;
	Tango::DevBoolean	*attr_OutputEnable_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	RfInp(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	RfInp(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	RfInp(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~RfInp();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : RfInp::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method     : RfInp::write_attr_hardware()
	 *	Description: Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute vlt related methods
 *	Description: Cavity Voltage-Direct Setting kV
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_vlt(Tango::Attribute &attr);
	virtual void write_vlt(Tango::WAttribute &attr);
	virtual bool is_vlt_allowed(Tango::AttReqType type);
/**
 *	Attribute vltSet related methods
 *	Description: Input Level Setting kV
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_vltSet(Tango::Attribute &attr);
	virtual bool is_vltSet_allowed(Tango::AttReqType type);
/**
 *	Attribute OutputEnable related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_OutputEnable(Tango::Attribute &attr);
	virtual bool is_OutputEnable_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : RfInp::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command Abort related method
	 *	Description: Abort Ramp
	 *
	 */
	virtual void abort();
	virtual bool is_Abort_allowed(const CORBA::Any &any);
	/**
	 *	Command Enable related method
	 *
	 *
	 */
	virtual void enable();
	virtual bool is_Enable_allowed(const CORBA::Any &any);
	/**
	 *	Command Disable related method
	 *
	 *
	 */
	virtual void disable();
	virtual bool is_Disable_allowed(const CORBA::Any &any);
	/**
	 *	Command FastRamp related method
	 *	Description: Start Fast Ramp
	 *
	 */
	virtual void fast_ramp();
	virtual bool is_FastRamp_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : RfInp::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(RfInp::Additional Method prototypes) ENABLED START -----*/
/* clang-format on */
	void check_init();
	void read_vlt();
	void write_vlt(const double &w_val);
	void read_vltSet();
	void read_enableIn();
	void write_enableOut(const int &w_val);

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInp::Additional Method prototypes
};

/*----- PROTECTED REGION ID(RfInp::Additional Classes Definitions) ENABLED START -----*/
/* clang-format on */
//	Additional Classes Definitions
class RfInpWorker : public omni_thread, public Tango::LogAdapter
{
	RfInp *device;
	void* run_undetached(void*);
	bool cont;
	enum { POLL, RAMP } action;
	// For ramping
	long steps;
	double vstep;
	double istep;

public:
	RfInpWorker(RfInp *device_) : 
		LogAdapter((Tango::DeviceImpl*)device_),
		device(device_), cont(false), action(POLL) {}
	void start() {
		cont = true;
		start_undetached();
	}
	void ramp();
	void abort();
	void stop() {
		cont = false;
	}
};
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInp::Additional Classes Definitions

}	//	End of namespace

#endif   //	RfInp_H
