/*----- PROTECTED REGION ID(RfInpClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfInpClass.h
//
// description : Include for the RfInp root class.
//               This class is the singleton class for
//                the RfInp device class.
//               It contains all properties and methods which the
//               RfInp requires only once e.g. the commands.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef RfInpClass_H
#define RfInpClass_H

#include <tango.h>
#include "RfInp.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInpClass.h


namespace RfInp_ns
{
/*----- PROTECTED REGION ID(RfInpClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInpClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute vlt class definition
class vltAttrib: public Tango::Attr
{
public:
	vltAttrib():Attr("vlt",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~vltAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfInp *>(dev))->read_vlt(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<RfInp *>(dev))->write_vlt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfInp *>(dev))->is_vlt_allowed(ty);}
};

//	Attribute vltSet class definition
class vltSetAttrib: public Tango::Attr
{
public:
	vltSetAttrib():Attr("vltSet",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~vltSetAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfInp *>(dev))->read_vltSet(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfInp *>(dev))->is_vltSet_allowed(ty);}
};

//	Attribute OutputEnable class definition
class OutputEnableAttrib: public Tango::Attr
{
public:
	OutputEnableAttrib():Attr("OutputEnable",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~OutputEnableAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfInp *>(dev))->read_OutputEnable(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfInp *>(dev))->is_OutputEnable_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Abort class definition
class AbortClass : public Tango::Command
{
public:
	AbortClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	AbortClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~AbortClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RfInp *>(dev))->is_Abort_allowed(any);}
};

//	Command Enable class definition
class EnableClass : public Tango::Command
{
public:
	EnableClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	EnableClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~EnableClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RfInp *>(dev))->is_Enable_allowed(any);}
};

//	Command Disable class definition
class DisableClass : public Tango::Command
{
public:
	DisableClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	DisableClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~DisableClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RfInp *>(dev))->is_Disable_allowed(any);}
};

//	Command FastRamp class definition
class FastRampClass : public Tango::Command
{
public:
	FastRampClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	FastRampClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~FastRampClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RfInp *>(dev))->is_FastRamp_allowed(any);}
};


/**
 *	The RfInpClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  RfInpClass : public Tango::DeviceClass
#else
class RfInpClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(RfInpClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfInpClass::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static RfInpClass *init(const char *);
		static RfInpClass *instance();
		~RfInpClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		RfInpClass(std::string &);
		static RfInpClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	RfInp_H
