/*----- PROTECTED REGION ID(RfInpStateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfInpStateMachine.cpp
//
// description : State machine file for the RfInp class
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "RfInp.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInp::RfInpStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  The decice is in ON state
//  OFF      |  The decice is in OFF state
//  UNKNOWN  |  The decice is in UNKNOWN state
//  FAULT    |  The decice is in FAULT state
//  ALARM    |  The decice is in ALARM state
//  MOVING   |  The decice is in MOVING state


namespace RfInp_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : RfInp::is_vlt_allowed()
 *	Description: Execution allowed for vlt attribute
 */
//--------------------------------------------------------
bool RfInp::is_vlt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::UNKNOWN ||
			get_state()==Tango::MOVING)
		{
		/*----- PROTECTED REGION ID(RfInp::vltStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	RfInp::vltStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(RfInp::vltStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	RfInp::vltStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : RfInp::is_vltSet_allowed()
 *	Description: Execution allowed for vltSet attribute
 */
//--------------------------------------------------------
bool RfInp::is_vltSet_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Check access type.
	if ( type==Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for READ
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(RfInp::vltSetStateAllowed_READ) ENABLED START -----*/
		/* clang-format on */
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	RfInp::vltSetStateAllowed_READ
			return false;
		}
		return true;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : RfInp::is_OutputEnable_allowed()
 *	Description: Execution allowed for OutputEnable attribute
 */
//--------------------------------------------------------
bool RfInp::is_OutputEnable_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for OutputEnable attribute in read access.
	/*----- PROTECTED REGION ID(RfInp::OutputEnableStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfInp::OutputEnableStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : RfInp::is_Abort_allowed()
 *	Description: Execution allowed for Abort attribute
 */
//--------------------------------------------------------
bool RfInp::is_Abort_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::ON ||
		get_state()==Tango::OFF ||
		get_state()==Tango::UNKNOWN ||
		get_state()==Tango::FAULT ||
		get_state()==Tango::ALARM)
	{
	/*----- PROTECTED REGION ID(RfInp::AbortStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfInp::AbortStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : RfInp::is_Enable_allowed()
 *	Description: Execution allowed for Enable attribute
 */
//--------------------------------------------------------
bool RfInp::is_Enable_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::UNKNOWN ||
		get_state()==Tango::MOVING)
	{
	/*----- PROTECTED REGION ID(RfInp::EnableStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfInp::EnableStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : RfInp::is_Disable_allowed()
 *	Description: Execution allowed for Disable attribute
 */
//--------------------------------------------------------
bool RfInp::is_Disable_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::UNKNOWN ||
		get_state()==Tango::MOVING)
	{
	/*----- PROTECTED REGION ID(RfInp::DisableStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfInp::DisableStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : RfInp::is_FastRamp_allowed()
 *	Description: Execution allowed for FastRamp attribute
 */
//--------------------------------------------------------
bool RfInp::is_FastRamp_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::UNKNOWN ||
		get_state()==Tango::MOVING)
	{
	/*----- PROTECTED REGION ID(RfInp::FastRampStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfInp::FastRampStateAllowed
		return false;
	}
	return true;
}


/*----- PROTECTED REGION ID(RfInp::RfInpStateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfInp::RfInpStateAllowed.AdditionalMethods

}	//	End of namespace
